unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtDlgs, Buttons, ExtCtrls, StdCtrls, Jpeg;

type
  TForm1 = class(TForm)
    ButtonLireDonnes: TButton;
    Image1: TImage;
    BitBtnChoixImage: TBitBtn;
    OpenPictureDialog1: TOpenPictureDialog;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure BitBtnChoixImageClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonLireDonnesClick(Sender: TObject);  
  private

  public
    { Dclarations publiques }
  end;
  // utilisation d'un type record qui nous permettra de stocker ce sue l'on veut
  TRecordDonnesStockesDansLeTag = Record
    NomFichier:String;
    DateFichier:TDateTime;
  end;
  // dfinition d'un type pointeur sur ce record.
  // par le biais d'un transtypage, le type pointeur est compatible avec le tag
  PTRecordDonnesStockesDansLeTag = ^TRecordDonnesStockesDansLeTag;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.BitBtnChoixImageClick(Sender: TObject);
var PDonnes:PTRecordDonnesStockesDansLeTag;
begin
  // libration de la mmoire point par le pointeur stock dans le Tag
  // s'il y en a un de stock
  // C'est  dire si on est dj pass par le New ci-dessous
  PDonnes:= PTRecordDonnesStockesDansLeTag(Image1.tag);
  if PDonnes<> nil then  Dispose(PDonnes); // libration de la mmoire


   // New permet de rserver un espace en mmoire pour les donns qui seront pointes par
   // PDonnes
   New(PDonnes);
               
  if OpenPictureDialog1.Execute then Image1.Picture.LoadFromFile(OpenPictureDialog1.FileName);
  PDonnes^.NomFichier:=OpenPictureDialog1.FileName;
  PDonnes^.DateFichier := FileDateToDateTime(FileAge(OpenPictureDialog1.FileName));
  Image1.Tag:=Integer(PDonnes); // transtypage d'un type pointeur vers un type entier pour pouvoir mettre le pointeur dans le tag
end;


procedure TForm1.ButtonLireDonnesClick(Sender: TObject);
Var PDonnes:PTRecordDonnesStockesDansLeTag;
begin
  PDonnes:= PTRecordDonnesStockesDansLeTag(Image1.tag);
  if PDonnes<> nil then
  begin
    Label3.Caption:=PDonnes^.NomFichier;
    Label4.Caption:=DateTimeToStr(PDonnes^.DateFichier);
  end;
end;


procedure TForm1.FormDestroy(Sender: TObject);
var PDonnes:PTRecordDonnesStockesDansLeTag;
begin
  // libration de la mmoire point par le pointeur stock dans le Tag
  // qui y est stock
  PDonnes:= PTRecordDonnesStockesDansLeTag(Image1.tag);
  if PDonnes<> nil then  Dispose(PDonnes);
end;

end.
